'use strict';

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

var backgroundTasks = {};
var objectHash = require('object-hash');

var _require = require('electron');

var ipcRenderer = _require.ipcRenderer;

var hasRegisteredListeners = false;

function registerListeners() {
  ipcRenderer.on('BACKGROUND_START', function (payload) {
    var moduleHash = payload.moduleHash;
    var funcName = payload.funcName;
    var args = payload.args;
    var eventKey = payload.eventKey;

    var backgroundPromise = new Promise(function (resolve, reject) {
      try {
        var _backgroundTasks$modu;

        var result = (_backgroundTasks$modu = backgroundTasks[moduleHash])[funcName].apply(_backgroundTasks$modu, _toConsumableArray(args));
        resolve(result);
      } catch (e) {
        reject(e);
      }
    });

    Promise.resolve(backgroundPromise).then(function (result) {
      ipcRenderer.send('BACKGROUND_REPLY', {
        result: result,
        eventKey: eventKey,
        resultType: 'BACKGROUND_RESOLVE'
      });
    }).catch(function (reason) {
      ipcRenderer.send('BACKGROUND_REPLY', {
        reason: reason,
        eventKey: eventKey,
        resultType: 'BACKGROUND_REJECT'
      });
    });
  });
}

var background = {
  registerModule: function registerModule(moduleName) {
    if (!hasRegisteredListeners) {
      registerListeners();
      hasRegisteredListeners = true;
    }
    var backgroundModule = require(moduleName);
    backgroundTasks[objectHash(backgroundModule)] = backgroundModule;
  }
};

module.exports = background;